unit Console;

interface

const
	Black = 0;
	Blue = 1;
	Green = 2;
	Cyan = 3;
	Red = 4;
	Magenta = 5;
	Brown = 6;
	LightGray = 7;
	DarkGray = 8;
	LightBlue = 9;
	LightGreen = 10;
	LightCyan = 11;
	LightRed = 12;
	LightMagenta = 13;
	Yellow = 14;
	White = 15;

var
	Screen: pchar =  PChar ($B8000);
	q, CursorX, CursorY: integer;
	Color: char;
	Background: integer = 0;
	backspace: array [0..4000] of integer;
	Command: PChar;
	e: integer = 0;

procedure ClearScreen;
procedure PrintStr(text: PChar);
procedure PrintInt(number:integer);
procedure PrintChar(ch: Char);
procedure SetColor(txt,back:integer);
procedure SetXY(x,y: integer);
procedure Scroll;
procedure Command2;

implementation

uses keyboard, pit, floppy, fat;

procedure ClearScreen; [public, alias: 'ClearScreen'];
var
	i: integer;
begin
	for i:=0 to 2000 do
	begin
		Screen[i*2]:=#0;
		Screen[i*2-1]:=char(white);
	end;
end;

procedure PrintStr(text: PChar);[public, alias: 'PrintStr'];
var
	address: Word;
	i: integer;
begin
	i:=0;
	if (CursorX > 79) or (text[i] = #13) then 
	begin
		SetXY(0, CursorY+1);
	end 
	else
	begin
		if (text[i] = #10) then
		begin
			SetXY(CursorX, CursorY+1);
		end
	else
	begin
		if (CursorY > 24) then
			begin
				SetXY(CursorX, 24);
				Scroll;
			end;

	repeat
		address:= CursorX*2 + CursorY * 160;
		Screen[address]:= text[i];
		Screen[address+1]:= color;	
		backspace[address]:=0;
		backspace[address+1]:=0;
		SetXY(CursorX+1, CursorY);
		i:=i + 1;
	until text[i] = #0

		end;
	end;
end;

procedure PrintInt(number: integer); [public, alias: 'PrintInt'];
var
	chars: array [0..11] of Char;
	negative: Boolean;
	i: integer;
	txt: PChar;
begin
	txt:= @chars[12];
	i:=11;
	negative:= False;
	if number<0 then 
	begin 
		number:=-number;
		negative:= True;
	end;

	repeat
		chars[i]:= char((number mod 10) + byte('0'));
		number:= number div 10;
		number-=1;
		Dec(txt);
	until number=0;

	if negative=True then
	begin
		PrintStr('-');
	end;

	PrintStr(txt);
end;

procedure PrintChar(ch: Char);[public, alias: 'PrintChar'];
var
	address: Word;
begin
	if (CursorX > 79) or (ch = #13) then
		SetXY(0, CursorY+1)
	else
	if ch = #10 then
		SetXY(CursorX, CursorY+1)
	else
	if CursorY > 24 then
	begin
		SetXY(CursorX, 24);
		Scroll;
	end;

	address:= CursorX*2 + CursorY * 160;
	Screen[address]:= ch;
	Screen[address+1]:= color;	
	backspace[address]:=0;
	backspace[address+1]:=0;
	SetXY(CursorX+1, CursorY);
end;

procedure SetColor(txt,back: integer); [public, alias: 'SetColor'];
begin
	color:=char(txt+back*16);
end;

procedure Scroll;[public, alias: 'Scroll'];
var
	address : word;
begin
	for address:=0 to 1920 do
	begin
		Screen[address*2] := Screen[address*2+160];
		Screen[address*2+1] := Screen[address*2+1+160];
	end;

	for address:=1921 to 2000 do
	begin
		Screen[address*2]:=#0;
		Screen[address*2+1]:=char(15); 
	end;		
end;

procedure SetXY(x,y: integer);[public, alias: 'SetXY'];
var
	temp: integer;
begin
	CursorX := x;
	CursorY := y;
	temp:=y*80+x;
	outportb($3D4, 14);
	outportb($3D5, temp>>8);
	outportb($3D4, 15);
	outportb($3D5, temp);
end;

procedure Command2;[public,alias:'Command2'];
var 
	pol : integer= 0;
	drive : byte;
	a:integer;
	i : integer = 0;
	Root_Dir : pchar = '/';
	q : pchar;
	b:integer=0;
	wynik: pchar;
	ii:integer =0;
begin
	cmd := 0;
	if (Command[0]='L') and (Command[1]='I') and (Command[2]='S') and (Command[3]='T') and (Command[4]=#0) then
	begin // list
	List('/');
	end
	else
	if (Command[0]='R') and (Command[1]='E') and (Command[2]='A') and (Command[3]='D') and (Command[4]=' ') then
	begin // read
		repeat
		begin
			wynik[i]:=command[i+5];
			i:=i+1;
		end;
                until command[i+4] = #0;
		ReadFile(wynik);
	end
	else
	if (Command[0]='E') and (Command[1]='X') and (Command[2]='I') and (Command[3]='T') and (Command[4]=#0) then
	begin // exit
		asm
			mov	al, 0feh
			out	64h, al
		end;
	end
	else
	if (Command[0]='H') and (Command[1]='E') and (Command[2]='L') and (Command[3]='P') and (Command[4]=#0) then
	begin // help
		PrintStr(#13);
		PrintStr('EXIT               - resetuje komputer');
		PrintStr(#13);
		PrintStr('HELP               - wyswietla pomoc');
		PrintStr(#13);
		PrintStr('READ <nazwa pliku> - odczytuje wskazany plik z dyskietki');
		PrintStr(#13);
		PrintStr('LIST               - wyswietla liste plikow z glownego katalogu');
	end
	else
	begin
		PrintStr(#13);
		PrintStr('Polecenie "');
		PrintStr(Command);
		PrintStr('" nie zostalo odnalezione.');
	end;

	e:=0;
	PrintStr(#13);
	SetColor(LightGray,Black);
	PrintStr(PathCurrentDir);
	PrintStr('>');
	SetColor(White,Black);
	repeat //czyszczenie zmiennej "Command"
		Command[pol]:=#0;
		pol+=1;
	until pol=100;
end;

end.